unit Respfrm;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, DWinSock, Buttons, PhBook, Header,
  ExtCtrls, Histfrm, Morefrm;

type
  TMainForm = class(TForm)
    Eingabe: TEdit;
    FaxLabel: TLabel;
    OKBtn: TBitBtn;
    CancelBtn: TBitBtn;
    Nutzer: TEdit;
    NutzerLabel: TLabel;
    Empfaenger: TEdit;
    EmpfaengerLabel: TLabel;
    Name: TEdit;
    Namelabel: TLabel;
    EmpfaengerKopf: TLabel;
    AbsenderKopf: TLabel;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Bevel3: TBevel;
    DelayedLabel: TLabel;
    DelayedEdit: TEdit;
    DelayedCheck: TCheckBox;
    BTList: TSpeedButton;
    MoreBtn: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure EingabeKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BTListClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MoreBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
    SaveEingabe: String;
    procedure ExecuteHistory;
    procedure ReadLabels;
    procedure ActivateControls;
  public
    { Public-Deklarationen }
    Delayed : TDelayed;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

procedure TMainForm.FormCreate(Sender: TObject);
begin
  ReadLabels;   { Set labels }
  ActivateControls;  { Enable controls if required }
end;

procedure TMainForm.EingabeKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if ( Shift = [] ) and ( Key = VK_DOWN ) then ExecuteHistory;
end;

procedure TMainForm.BTListClick(Sender: TObject);
begin
  ExecuteHistory;
end;

procedure TMainForm.ExecuteHistory;
{ Showmodal history+alias window and fill edit fields from selected entry }
var
 i, j: Integer;
 s : String;
 a : PAlias;
begin
  HistForm := THistForm.Create(Self);
  with HistoryList do for i := 0 to HistoryList.Count-1 do
    HistForm.LBAlias.Items.Add(Strings[i]+': '+StrPas(PChar(Objects[i])));
  with PhoneBook do for i := 0 to Count-1 do
    HistForm.LBAlias.Items.Add( Strings[i] );
  SaveEingabe := Eingabe.Text;
  if HistForm.ShowModal = IDOK then begin
    j := HistForm.LBAlias.ItemIndex;
    with HistForm.LBAlias do if j >= 0 then begin
      s := Items.Strings[j];
      if ItemIndex < HistoryList.Count then begin
        { if selected item is from history list }
        i := Pos(':',s);
        if i > 0 then begin
          if SaveEingabe = '' then
            Empfaenger.Text := Copy( s, i+2, Length( s ))
          else begin
            Empfaenger.Text := '';
            AppendStr( SaveEingabe, ' ' );
          end;
          Eingabe.Text := SaveEingabe+Copy( s, 1, i-1 );
          SaveEingabe := Eingabe.Text;
        end;
      end else begin
        { else it must be from alias list }
        i := PhoneBook.IndexOf( s );
        if i >= 0 then begin
          a := PAlias(PhoneBook.Objects[i]);
          if SaveEingabe = '' then
            Empfaenger.Text := a^.Empfaenger
          else begin
            Empfaenger.Text := '';
            AppendStr( SaveEingabe, ' ' );
          end;
          Eingabe.Text := SaveEingabe+a^.FaxNum;
          SaveEingabe := Eingabe.Text;
        end;
      end;
    end;
  end;
  HistForm.Free;
end;

procedure TMainForm.ReadLabels;
{ Labels aus WIN.INI lesen }
begin
  EmpfaengerKopf.Caption := GetLabelStr(KIReceiver);
  FaxLabel.Caption := GetLabelStr(KIFaxNums);
  EmpfaengerLabel.Caption := GetLabelStr(KIRecvName);
  AbsenderKopf.Caption := GetLabelStr(KISender);
  NutzerLabel.Caption := GetLabelStr(KIUser);
  NameLabel.Caption := GetLabelStr(KISendName);
  OKBtn.Caption := GetLabelStr(KIOK);
  CancelBtn.Caption := GetLabelStr(KICancel);
  DelayedCheck.Caption := GetLabelStr(KIDelayed);
  DelayedLabel.Caption := GetLabelStr(KIDelayed);
  MoreBtn.Caption := GetLabelStr(KIMore);
end;

procedure TMainForm.ActivateControls;
{ Make cotrols visible if required }
begin
  Delayed := TDelayed(GetPrivateProfileInt( OptionsSection, DelayedKey, 0, WinIni ));
  case Delayed of
    dCheck: DelayedCheck.Visible := True;
    dEdit:  begin
      DelayedEdit.Visible := True;
      DelayedLabel.Visible := True;
    end;
  end;
  if GetPrivateProfileInt( OptionsSection, QueryReceiverNameKey, 1, WinIni ) = 0 then begin
    EmpfaengerLabel.Visible := False;
    Empfaenger.Visible := False;
  end;
  if GetPrivateProfileInt( OptionsSection, QueryUserKey, 1, WinIni ) = 0 then begin
    NutzerLabel.Visible := False;
    Nutzer.Visible := False;
  end;
  if GetPrivateProfileInt( OptionsSection, QuerySenderNameKey, 1, WinIni ) = 0 then begin
    NameLabel.Visible := False;
    Name.Visible := False;
    if Nutzer.Visible = False then AbsenderKopf.Visible := False;
  end;
  if GetPrivateProfileInt( OptionsSection, MoreKey, 1, WinIni ) = 0 then begin
    MoreBtn.Visible := False;
  end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;


procedure TMainForm.MoreBtnClick(Sender: TObject);
begin
  MoreForm := TMoreForm.Create(self);
  MoreForm.ShowModal;
  MoreForm.Free;
  if (MoreStrings <> nil) and (MoreStrings.Count > 0) then
    MoreBtn.Caption := GetLabelStr(KIMore)+'...'
  else
    MoreBtn.Caption := GetLabelStr(KIMore);
end;

end.
